import java.awt.*;

class Hanoi {

        HanoiStack[] tower;
        int diskNum;
        int moveNum;

        public Hanoi(int d,DBCanvas c)
          {
              diskNum = d;
              tower = new HanoiStack[3];
              tower[0] = new HanoiStack(diskNum,10,450);
              tower[1] = new HanoiStack(0,260,450);
              tower[2] = new HanoiStack(0,510,450);
              c.fillBackground(Color.white);
              for (int i=0;i<3;i++) tower[i].draw(c,false);
              c.showBuffer();
              moveNum = 0;
          }

          
        public void solve(int d,int startpeg, int endpeg, int helppeg,DBCanvas c)

            {
               if (d==1) {
                    moveNum++;
                    move(startpeg,endpeg,c);
                 }
               else {
                   solve(d-1,startpeg,helppeg,endpeg,c);
                   moveNum++;
                   move(startpeg,endpeg,c);
                   solve(d-1,helppeg,endpeg,startpeg,c);
                 }
            }

       private void drawMove(Disk t,int s,DBCanvas c)
           {
               c.fillBackground(Color.white);
               c.setInkColor(Color.black);
               String mn = new String("Move " + moveNum);
               c.drawString(mn,50,50);
               for (int i=0;i<3;i++) {
                 if (i==s) tower[i].draw(c,true);
                 else tower[i].draw(c,false);
                }
               t.draw(c);
               c.showBuffer();
               c.wait(7);
            }
               
       private void lift(Disk t,int start,int stop,int n,int s,DBCanvas c)
           {
              int dy = stop-start;
              for (int j = 0;j<=n;j++)  {
                t.currentY = start + (j*dy)/n; 
                drawMove(t,s,c);
               }
           }

       private void slide(Disk t,int start,int stop,int n,int s,DBCanvas c)
           {
              int dx = stop-start;
              for (int j = 0;j<=n;j++)  {
                t.currentX = start + (j*dx)/n; 
                drawMove(t,s,c);
               }
           }

       private void drop(Disk t,int start,int stop,int n,int s,DBCanvas c)
           {
              int dy = stop-start;
              for (int j = 0;j<=n;j++)  {
                t.currentY = start + (j*dy)/n; 
                drawMove(t,s,c);
               }
           }
 
       private void move(int s,int e,DBCanvas c)
           {
               Disk t = tower[s].getTopDisk();
               int x = t.xpos - tower[s].xpos + tower[e].xpos;
               int n = 50;
               lift(t,t.ypos, tower[s].ypos-220,n,s,c); 
               slide(t,t.xpos,x,n,s,c);
               drop(t,t.currentY, tower[e].getNextYTop(),n,s,c);
               t = tower[s].remove();
               tower[e].add(t);
          }
 
}
