import java.awt.*;

class HanoiStack {

     int xpos,ypos,diskNum;
     Disk[] disk;

     public HanoiStack(int d, int x, int y)
       {
           xpos = x;
           ypos = y;
           disk = new Disk[12];
           diskNum = d;
           for (int i=0;i<diskNum;i++) disk[i] = new Disk(200-i*20,xpos+10*i,ypos-20*i);
       }

     public Disk getTopDisk()
       {
           return disk[diskNum-1];
       }

     public int getCurrentXTop()
       {
           if (diskNum>0) return disk[diskNum-1].xpos;
           else return xpos;
       }

     public int getNextXTop()
       {
           if (diskNum>0) return disk[diskNum-1].xpos + 10;
           else return xpos+10;
       }

     public int getNextYTop()
       {
           if (diskNum>0) return disk[diskNum-1].ypos -20;
           else return ypos-20;
       }

     public int getCurrentYTop()
       {
           if (diskNum>0) return disk[diskNum-1].ypos;
           else return ypos;
       }

     public void draw(DBCanvas c,boolean noTop)
       {
          c.setInkColor(Color.black);
          c.fillRectangle(xpos+90,ypos-200,20,220);
          int n;
          if (noTop) n = diskNum-1; else n = diskNum;
          for (int i=0;i<n;i++) disk[i].draw(c);
       }

     public Disk remove()
      {
         diskNum--;
         disk[diskNum].xpos -= xpos;
         return disk[diskNum];
      }
     
     public void add(Disk t)
      {
         disk[diskNum] = t;
         disk[diskNum].xpos += xpos ;
         disk[diskNum].ypos = ypos - 20*diskNum;
         disk[diskNum].currentX = disk[diskNum].xpos;
         disk[diskNum].currentY = disk[diskNum].ypos;
         diskNum++;
      }
}
          
